<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                删除
            </el-button>
            <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form :model="formData" :rules="rules" ref="form" label-width="108px" label-position="right"
                         size="small"
                         style="max-width: 500px;">
                        <el-form-item prop="userId" label="用户ID">
                                    <el-input-number type="number" v-model="formData.userId"></el-input-number>
                        </el-form-item>
                        <el-form-item prop="avatar" label="用户头像">
                                    <el-input v-model="formData.avatar"></el-input>
                        </el-form-item>
                        <el-form-item prop="user" label="用户昵称">
                                    <el-input v-model="formData.user"></el-input>
                        </el-form-item>
                        <el-form-item prop="auctionId" label="拍卖活动ID">
                                    <el-input-number type="number" v-model="formData.auctionId"></el-input-number>
                        </el-form-item>
                        <el-form-item prop="name" label="拍卖活动">
                                    <el-input-number type="number" v-model="formData.name"></el-input-number>
                        </el-form-item>
                        <el-form-item prop="auctionPic" label="拍卖活动图片">
                                    <el-input v-model="formData.auctionPic"></el-input>
                        </el-form-item>
                        <el-form-item prop="type" label="类型">
                                    <el-select v-model="formData.type" clearable filterable placeholder="请选择">
                                        <el-option
                                                v-for="item in typeOptions"
                                                :key="item.value"
                                                :label="item.label"
                                                :value="item.value">
                                        </el-option>
                                    </el-select>
                        </el-form-item>
                        <el-form-item prop="purchased" label="是否竞得">
                                    <el-input v-model="formData.purchased"></el-input>
                        </el-form-item>
                        <el-form-item prop="bidderPrice" label="出价">
                                    <el-input-number type="number" v-model="formData.bidderPrice"></el-input-number>
                        </el-form-item>
                    <el-form-item class="form-submit">
                        <el-button @click="onSave" :loading="saving" type="primary">
                            保存
                        </el-button>
                        <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                            删除
                        </el-button>
                        <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
    export default {
        name: 'AuctionRecordEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('auctionRecord/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
                typeOptions: [{"label":"保证金","value":"DEPOSIT"},{"label":"竞拍","value":"BIDDER"},{"label":"一口价","value":"FIXEDPRICE"}],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/auctionRecord/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$confirm('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/auctionRecord/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped></style>
